/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package riverraid;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.awt.image.ImageObserver;
import java.awt.image.ImageProducer;
import java.util.ArrayList;
import java.util.Timer;
import javax.swing.ImageIcon;

/**
 *
 * @author kalvim
 */
public class Aviao extends Elemento{
    
    protected int combustivel;
    protected int vidas;
    
    public Aviao(int x, int y,Image img, JogoPrincipal jogo) {
        super(x, y,img, jogo);
        altura = 20;
        largura = 20;
        combustivel = 500;
        vidas  = 3 ;
    }

    public void consomeComb(int fator){
        combustivel -= fator;
    }
    
    public Tiro atirar(){
        Tiro t = new Tiro(this.coordX+11, this.coordY,null, jogo);
        return t;
    }
    @Override
    public void atualizarCoordenada() {    
        int tecla = 0;
        if(this.jogo.teclado.teclaApertada(KeyEvent.VK_UP) && this.coordY != 0){
            this.coordY -= 10;
            consomeComb(5);
            tecla = 1;
        }
        if(this.jogo.teclado.teclaApertada(KeyEvent.VK_DOWN) && this.coordY != 600){
            this.coordY += 10;
            consomeComb(1);
            tecla = 1;
        }
        if(this.jogo.teclado.teclaApertada(KeyEvent.VK_LEFT) && this.coordX != 0){
            this.coordX -= 10;
            consomeComb(2);
            tecla = 1;
        }
        if(this.jogo.teclado.teclaApertada(KeyEvent.VK_RIGHT) && this.coordX != 590){
            this.coordX += 10;
            consomeComb(2);
            tecla = 1;
        }
        if(tecla == 0){
            consomeComb(2);
        }
        
    }
    
    

    @Override
    public boolean bateParede(short cenario[][]){
        int coluna = coordX / 20; 
        int linha = coordY / 19; 
        
        
        if((cenario[linha][coluna] == 0) || (cenario[linha][coluna+1] == 0) || (cenario[linha][coluna] == 3) || (cenario[linha][coluna+1] == 3)){
            return true;
        }
        
        return false;
    }
    
    public void abastece(ArrayList<Posto> postos){
        for (Posto p : postos) {
            if(colidiu(p.obtemElemento())){
                if (combustivel+50 <= 400){
                    combustivel+=50;
                }else{
                    combustivel = 400;
                }
            }
        }
    }
    
   

    
    
}
