/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package riverraid;

import java.awt.Rectangle;
import java.awt.Image;
import java.util.ArrayList;
import java.util.Timer;
import javax.swing.ImageIcon;



/**
 *
 * @author kalvim
 */
public abstract class Elemento{
    protected Image img;
    protected int estado;
    protected int coordY;
    protected int coordX;
    protected int largura = 20;
    protected int altura = 20;
    protected JogoPrincipal jogo;
    
    public Elemento(int x, int y,Image img, JogoPrincipal jogo){
        this.img = img;
        this.coordX = x;
        this.coordY = y;
        this.jogo = jogo; 
        this.estado = 1;
    }

    public int getCoordX() {
        return coordX;
    }

    public void setCoordX(int coordX) {
        this.coordX = coordX;
    }

    public int getCoordY() {
        return coordY;
    }

    public void setCoordY(int coordY) {
        this.coordY = coordY;
    }
    
    public abstract void atualizarCoordenada();
    
    public Rectangle obtemElemento(){
      return new Rectangle(coordX, coordY, largura, altura) {};
    }
    
    public boolean colidiu(Rectangle r){
        return this.obtemElemento().intersects(r);
    }
    
    public abstract  boolean bateParede(short cenario[][]);
}
